unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  winsock,StdCtrls,Zniffer, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    ComboBox1: TComboBox;
    ListView1: TListView;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    Fsearch : boolean;
    FZniffer : TZniffer;
    FlastPort:word;
    FlastAddr:integer;
    Function ProtocolStr(protocol:byte):string;
    function IPtoStr(IP:pbyte):string;
    procedure ReadPacket(Data:pointer;recvbytes:Word);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 Fzniffer := TZniffer.create;
 Fzniffer.OnPacket := ReadPacket;
 Combobox1.Items.assign(Fzniffer.Adapters);
 Combobox1.text:='< SELECT ADAPTER >';
 Combobox1.Itemindex := 0;
 Combobox1.OnChange(nil);
 Fsearch := true;
 FlastPort:=0;
 FlastAddr:=0;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var E:string;
begin
  if Fzniffer.Snooping then
    if not Fzniffer.Deactivate(E) then  raise Exception.create(e);
  Fzniffer.AdapterIndex := COmbobox1.ItemIndex;
  if not Fzniffer.Activate(e) then raise Exception.create(e);
  caption := 'Snooping Started';
end;

procedure TForm1.ReadPacket(Data: pointer; recvbytes: Word);
var L,P : integer;
  IP  : PIP_RHDR;
  TCP : PTCP_RHDR;
  IPlen : integer;
begin

  IP := @PETHERNET_HDR(data).data;

  With Listview1.items.add do begin

    //protocol
    Caption := ProtocolStr( IP.Protocol );

    //version   : IP.Verlen shr 4 ;
    //IP Length : (IP.Verlen AND $0F) * 8;
    //total packet length: recvbytes;

    // Get TCP data :
    TCP :=@IP.data;

    SubItems.Add(IPtoStr(@ip.srcIP[0]));

    if IP.Protocol=6 then
      Subitems.add( inttostr( ntohs(TCP.SrcPort) ) )
    else Subitems.add('');

    SubItems.Add(IPtoStr(@ip.destIP[0]));


    if IP.Protocol=6 then
      Subitems.add( inttostr( ntohs(TCP.DestPort) ) )
    else SubItems.add('');



  end;
end;

function TForm1.ProtocolStr(protocol: byte): string;
begin
  case protocol of
    1 : result := 'ICMP';
    6 : result := 'TCP';
    17: result := 'UDP';
    80: result := 'ISO IP';
    else result:= inttostr(protocol);
  end;
end;

function TForm1.IPtoStr;
type
  PIP = ^TIP;
  TIP = array[0..3] of byte;
begin
  result := format('%d.%d.%d.%d',[PIP(IP)[0],
                                  PIP(IP)[1],
                                  PIP(IP)[2],
                                  PIP(IP)[3]]);
end;

procedure TForm1.Button1Click(Sender: TObject);
var E:string;
begin
  if FZniffer.Deactivate(E) then
    caption := 'Snooping Stopped'
  else
    caption:=E;
end;

end.
